

; END OF DATA AROUND &0F40
; END OF REUSABLE AREA AROUND &1020

; SET STRUCTURE OF INITIAL VARIABLES
initiatevars:
  ; COPY INITIAL FIXED SPRITES TO TRANSIENT SPRITE LIST
  ; IF WE RESTART THE GAME, WE NEED TO MAKE SURE INITIAL GAME OBJECTS ARE RESTORED
  ld de,quests_fixed_sprites
  ld hl,quests_fixed_sprites_list
  ld bc,fixedspritelistsizeend-fixedspritelistsizestart
  ldir

  ; RESET TREASURE CHEST STATUSES IF WE RESTART GAME
  ld hl,treasurechestrewards+2
  resettreasurechestloop:
    ld a,(hl)
    cp 255
    jr z,finishedresettreasurechestloop
    ld (hl),0
    inc hl
    inc hl
    inc hl
    inc hl
  jr resettreasurechestloop
  finishedresettreasurechestloop

  ; RESET QUESTS AND RANDOM QUEST DATA
  ld hl,quest_data_handsfull
  ld bc,66
  call clearmem

  ; MAKE SURE WE RESET LEVEL DEPTH
  call delleveldepth
  call delleveldepth
  call delleveldepth

  ; CLEAR DISCOVERED TOWNS IF WE RESTART GAME
  ld hl,discoveredtownstable
  ld bc,102
  call clearmem
  ;xor a
  ;call fillloop5

  ; CLEAR INVENTORY IF WE RESTART GAME
  ld hl,player_inventory_rand
  ld bc,15
  call clearmem;fillloop5

  ; CLEAR WANTED LEVEL IF WE RESTART GAME
  ld bc,0
  ld (bountyreward-2),bc 
  ld bc,1000
  ld (player_cash2),bc   ; RESET CASH

  ; RESET ROOM PSEUDO RANDOM FOR HOME HOUSE
  ld a,&58
  ld (tilenum_cur),a    

  ; SET FIXED SPRITE IDS, USED BY PLAYER AND ARROWS
  ;ld hl,spriteidlist
  ;ld a,1
  ;ld (hl),a   ; SET FIRST SPRITE BUFFER USED BY PLAYER
  ;inc hl
  ;ld (hl),a ; SET SECOND SPRITE BUFFER USED BY PLAYER ARROW
  ;inc hl
  ;ld (hl),a ; SET THIRD SPRITE BUFFER USED BY MCP ARROW

  ; SET INITIAL PLAYER SPRITE POSITIONS
  ld ix,playerspritedata
  ld (ix+0),2            ; PLAYER
  ld a,initialposbuild
  ld (ix+3),a            ; IN BUILDING
  ld (inbuilding),a
  ld a,initialmapx
  ld (tilemap_cur),a
  ld (ix+4),a            ; X MAP START POS
  ld a,initialmapy
  ld (tilemap_cury),a
  ld (ix+5),a            ; Y MAP START POS
  ld (ix+6),initialposx  ; X BYTE POS
  ld (ix+7),initialposy  ; Y LINE POS
  ld (ix+10),0           ; SPRITE LEFT IMAGE
  ld (ix+11),4           ; SPRITE DOWN IMAGE
  ld (ix+12),6           ; SPRITE UP IMAGE

  ld (ix+20),%10011001   ; SET MIMO'S NAME (NIBBLES - SEE NAMES TABLES IN DICTIONARY.ASM)

  ; ----- RESET SHIPPING -----

  call resetdocks
  ld a,b_dock
  ld (medievaldock_selfmod-1),a

  ; ----- PLAYER INVENTORY -----

  ; GET FOOD
ifdef givemefood
  ld b,2
  call addplayerinvrand_cf
  ld b,8
  call addplayerinvrand_cf
  ld b,8
  call addplayerinvrand_cf
  ld b,8
  call addplayerinvrand_cf
  ld b,8
  call addplayerinvrand_cf
  ld b,8
  call addplayerinvrand_cf
  ld b,8
  call addplayerinvrand_cf
  ld b,8
  call addplayerinvrand_cf
endif

ifdef givemeswimming
  ld b,15 ; LOAD FLIPPER ID
  call addplayerinvrand_cf
  ld b,snorkel ; LOAD SNORKEL 
  call addplayerinvrand_cf
endif
ifdef givemeflippers
  ld b,15 ; LOAD FLIPPER ID
  call addplayerinvrand_cf
  ;ld b,snorkel ; LOAD SNORKEL 
  ;call addplayerinvrand_cf
endif

ifdef givememaps
  ld b,localmap_id ; LOAD LOCAL MAP ID
  call addplayerinvrand_cf
  ld b,globalmap_id ; LOAD GLOBAL MAP ID
  call addplayerinvrand_cf
endif
ifdef givemekey
  ld b,key_id
  call addplayerinvrand_cf
endif
ifdef givemerope
  ld b,rope_id ; LOAD ARROW ID
  call addplayerinvrand_cf
endif

ifdef givemequill
  ld b,13 ; QUILL ID
  ;ld b,axe_id ; LOAD ARROW ID
  ;ld b,key_id
  call addplayerinvrand_cf
endif

ifdef givemeitems
  ld b,15 ; LOAD FLIPPER ID
  call addplayerinvrand_cf
  ;ld b,32 ; LOAD LOCKET
  ;call addplayerinvrand_cf
  ;ld b,rope_id ; LOAD ARROW ID
  ;call addplayerinvrand_cf
  ;ld b,5 ; LOAD BOW ID
  ;call addplayerinvrand_cf
  ld b,localmap_id ; LOAD LOCAL MAP ID
  call addplayerinvrand_cf
  ld b,globalmap_id ; LOAD GLOBAL MAP ID
  call addplayerinvrand_cf
  ;ld b,13 ; QUILL ID
  ld b,axe_id ; LOAD ARROW ID
  ;ld b,key_id
  call addplayerinvrand_cf
  ;ld b,29 ; LOAD COMPASS
  ;call addplayerinvrand_cf
  ld b,snorkel ; LOAD HOUSE KEYS  
  call addplayerinvrand_cf
  ;ld b,100
  ;loopyarrow:
  ;  push bc
  ;  ld b,arrow_id ; LOAD ARROW ID
  ;  call addplayerinvrand_cf
  ;  pop bc
  ;djnz loopyarrow
endif

ifdef givemeaxe
  ld b,axe_id ; LOAD ARROW ID
  call addplayerinvrand_cf
endif
ifdef givemetome
  ld b,ancienttome_id ; LOAD ARROW ID
  call addplayerinvrand_cf
endif
ifdef givemepickaxe
  ld b,pickaxe_id ; LOAD ARROW ID
  call addplayerinvrand_cf
endif
ifdef givemelongbow
  ld b,19 ; LOAD ARROW ID
  call addplayerinvrand_cf
  ld b,100
  loopyarrow:
    push bc
    ld b,arrow_id ; LOAD ARROW ID
    call addplayerinvrand_cf
    pop bc
  djnz loopyarrow
endif

  ; MOVE MIMO INTO HOUSE  
  ld a,(tilenum_cur)
  ld c,a
  call checkdoor

  ; ----- SET TIME -----

  ld a,1
  ld (weekday),a 

  ;ld a,(nighttime)
  xor a
  ld (nighttime),a
ret

; INPUTS
; B = NUMBER OF BYTES TO FILL
; A = VALUE TO FILL
; HL = MEMORY ADDRESS TO START AT
fillloop5:
  ld (hl),a
  inc hl
  djnz fillloop5
ret

  ; MCP DATA STRUCTURE
  ; RABBIT
  ;defb 0  ; 0 - STATUS 0 - INACTIVE, 1 - ACTIVE, 2 - PLAYER
  ;defb 0  ; 1 - CURRENT SPRITE IMAGE NUMBER TO DISPLAY
  ;defb 0  ; 2 - STATUS OF SPRITE
  ;              BIT 0 SET = CHARACTER KILLED  - 0 = NO,  1 = YES
  ;              BIT 1 SET = HAS BUFFER        - 0 = NO,  1 = YES
  ;              BIT 2 SET = SUBMERGED         - 0 = NO,  1 = YES
  ;              BIT 3 SET = HAS MOVED, REDRAW - 0 = YES, 1 = NO
  ;              BIT 4 SET = HAS FLIPPER POWER - 0 = NO,  1 = YES
  ;              BIT 5 SET = HAS ROPE POWER    - 0 = NO,  1 = YES
  ;              BIT 6 SET = IS BOUNTY HUNTER  - 0 = NO,  1 = YES
  ;              BIT 7 SET = HAS SNORKEL POWER - 0 = NO,  1 = YES
  ;defb 0  ; 3 - IN BUILDING TYPE
  ;defb 0  ; 4 - MAP X POS
  ;defb 0  ; 5 - MAP Y POS
  ;defb 0  ; 6 - CURR X BYTE POS
  ;defb 0  ; 7 - CURR Y LINE POS
  ;defb 0  ; 8 - CURR DIRECTION 0 - NOTHING, 1 - NORTH, 2 - NE, 3 - EAST
  ;defb 0  ; 9 - MOVE COUNTER, 0 MEANS WE HAVE ARRIVED AT DESTINATION
  
  ; SPRITE IMAGES ARE INCREMENTED EACH TIME IT IS DRAWN TO THE SCREEN
  ; THESE NUMBERS ARE THE FIRST IMAGE IN THE CYCLE

  ;defb 0  ; 10 - SPRITE LEFT IMAGE 1
  ;defb 0  ; 11 - SPRITE UP IMAGE 1
  ;defb 0  ; 12 - SPRITE DOWN IMAGE 1
  ;defb 0  ; 13 - SPRITE FLIPPED ? 0 = NO, 1 = HORIZ, 2 = VERT, 3 = HORIZ VERT

  ;defb 0  ; 14 - IF SPRITE IS WEAPON, ID OF SPRITE THAT FIRED IT - SO WE DON'T HURT OURSELVES
  ;defb 0  ; 15 - IF SPRITE IS ENEMY, 0 = NO, 1 = ENEMY, 2 = WANTED MAN - CASH REWARD WHEN KILLED
  ;defb 0  ; 16 - PREV X BYTE POS
  ;defb 0  ; 17 - PREV Y LINE POS

  ;defb 0  ; 18 - OBJECT ID IF IT IS AN OBJECT THAT CAN BE PICKED UP - THIS IMAGE OVERRIDES ANIMATION
  ;defb 0  ; 19 - CURRENT SPRITE OFFSET FOR ANIMATION

  ;defb 0  ; 20 - FIRST AND LAST NAME IN NIBBLES
 
  ;defb 0  ; 21 - DESTINATION MAP X
  ;defb 0  ; 22 - DESTINATION MAP Y
  ;defb 0  ; 23 - DESTINATION TILE
  ;defb 0  ; 24 - 0 = MOVE RANDOMLY, 1 = MOVE DEST, 2 = MOVE TO PLAYER, 3 = MOVE STRAIGHT, 4 = STATIONARY, 5 = MARCH LEFT AND RIGHT, 6 = LOCK TO PLAYER LOCATION

  ;defb 0  ; 25 - STATUS OF SPRITE 2
  ;               NOT USED - BIT 0 SET = IS LOCALISED SPRITE - 0 = NO,  1 = YES. IF YES, SPRITE CANNOT MOVE OUTSIDE SCREEN, IS DEACTIVATED WHEN PLAYER MOVES OUTSIDE SCREEN.

  ; COLLISION DETECTION? - 0 - MOVEMENT OK
  ;                      255 - CANNOT MOVE


  ;defb 0  ; 26 - SPRITE ID, ALSO OFFSET FOR TILE LOCATION DATA
  ;defb 0  ; 27 - SPRITE TYPE, 0 = PLAYER, 1 = PERSON, 2 = ANIMAL, 3 = WEAPON, 4 = PICKUP OBJECT, 5 = MOVEABLE OBJECT - USED FOR COLLISION DETECTION

  ;defb 0  ; 28 - COLLISION DETECTION? ID OF SPRITE THAT WE COLLIDED WITH


tilenum_cur:  defb &58 ; TILE NUMBER PLAYER IS CURRENTLY OCCUPYING (NEEDS SET TO GET CORRECT RANDOMIZATION OF START HOUSE)

ifdef isplus

; PLUS PALETTE GETS DIMMED BASED ON VALUE IN THIS BYTE
; 0=DARK 15=LIGHT, BRIGHTNESS LEVEL
; UPLOADED PALETTE IS DIMMED BASED ON THIS LEVEL
; EACH NIBBLE HAS TO BE ADJUSTED SEPARATELY AND NOT GO BELOW 0
;darknessoffset defb 0

pens:
  ;   RB-G
  ;defw &0000 ; TRANS
  ;defw &FF0F ; WHITE
  ;defw &0000 ; BLACK
  ;defw &5000 ; BROWN  
  ;defw &F000 ; RED
  ;defw &0C05 ; BLUE
  ;defw &F90C ; YELLOW 
  ;defw &F006 ; ORANGE
  ;defw &5403 ; PURPLE
  ;defw &9F09 ; LIGHT BLUE
  ;defw &5C03 ; MED BLUE
  ;defw &370A ; LIGHT GREEN
  ;defw &3506 ; SEA GREEN
  ;defw &3905 ; TEAL
  ;defw &0805 ; MAUVE
  ;defw &0005 ; DARK GREEN
  ;defw &0C05 ; BORDER

  ;defw &0000 ; TRANS
  ;defw &FF0F ; WHITE
  ;defw &0000 ; BLACK
  ;defw &5000 ; BROWN  
  ;defw &F000 ; RED
  ;defw &0C05 ; BLUE
  ;defw &F90A ; YELLOW 
  ;defw &F006 ; ORANGE
  ;defw &5403 ; PURPLE
  ;defw &9F09 ; LIGHT BLUE
  ;defw &5C05 ; MED BLUE
  ;defw &370A ; LIGHT GREEN
  ;defw &3506 ; SEA GREEN
  ;defw &3905 ; TEAL
  ;defw &0805 ; MAUVE
  ;defw &0005 ; DARK GREEN
  ;defw &0C05 ; BORDER

  defw &0000 ; TRANS
  defw &FF0F ; WHITE
  defw &0000 ; BLACK
  defw &8000 ; BROWN  
  defw &F000 ; RED
  defw &0F00 ; BLUE
  defw &F00F;A ; YELLOW 
  defw &F008;A;6 ; ORANGE
  defw &5403 ; PURPLE
  defw &8F0A;9 ; LIGHT BLUE
  defw &5C05 ; MED BLUE
  defw &370F;A ; LIGHT GREEN
  defw &350A;6 ; SEA GREEN
  defw &3905 ; TEAL
  defw &0805 ; MAUVE
  defw &0005 ; DARK GREEN
  defw &0C05 ; BORDER

penswater:
  ;   RB-G
  defw &0000 ; TRANS
  defw &FF0F ; WHITE
  defw &0000 ; BLACK
  defw &0500 ; BROWN  
  defw &0F00 ; RED
  defw &0C05 ; BLUE
  defw &0F0F ; YELLOW 
  defw &0F06 ; ORANGE
  defw &0503 ; PURPLE
  defw &0F05 ; LIGHT BLUE
  defw &0B01 ; MED BLUE
  defw &030B ; LIGHT GREEN
  defw &0506 ; SEA GREEN
  defw &0905 ; TEAL
  defw &0805 ; MAUVE
  defw &0005 ; DARK GREEN
  defw &0C05 ; BORDER
endif

ifndef isplus
;; the inks for the pens
pens: ; DAY
  defb 9  ;0  TRANSPARENT/BACKGROUND
  defb 26 ;1  WHITE
  defb 0  ;2  BLACK
  defb 3  ;3  BROWN
  defb 6  ;4  RED
  defb 2  ;5  BLUE
  defb 24 ;6  YELLOW
  defb 15 ;7  ORANGE
  defb 5  ;8  PURPLE
  defb 20 ;9  LIGHT BLUE
  defb 14 ;10 MEDIUM BLUE
  defb 21 ;11 LIGHT GREEN
  defb 12 ;12 SEA GREEN
  defb 10 ;13 TEAL
  defb 4  ;14 MAUVE
  defb 9  ;15 DARK GREEN
penswater:
  defb 14 ;0  TRANSPARENT/BACKGROUND
  defb 26 ;1  WHITE
  defb 0  ;2  BLACK
  defb 5  ;3  BROWN
  defb 2  ;4  RED
  defb 2  ;5  BLUE
  defb 20 ;6  YELLOW
  defb 14 ;7  ORANGE
  defb 5  ;8  PURPLE
  defb 20 ;9  LIGHT BLUE
  defb 14 ;10 MEDIUM BLUE
  defb 21 ;11 LIGHT GREEN
  defb 12 ;12 SEA GREEN
  defb 10 ;13 TEAL
  defb 4  ;14 MAUVE
  defb 9  ;15 DARK GREEN
pens_night:
  defb 0  ;9  0  TRANSPARENT/BACKGROUND
  defb 25 ;26 1  WHITE
  defb 0  ;0  2  BLACK
  defb 0  ;3  3  BROWN
  defb 3  ;6  4  RED
  defb 5  ;2  5  BLUE
  defb 15 ;24 6  YELLOW
  defb 6  ;15 7  ORANGE
  defb 0  ;5  8  PURPLE
  defb 14 ;20 9  LIGHT BLUE
  defb 4  ;14 10 MEDIUM BLUE
  defb 12 ;21 11 LIGHT GREEN
  defb 10 ;12 12 SEA GREEN
  defb 9  ;10 13 TEAL
  defb 2  ;4  14 MAUVE
  defb 0  ;9  15 DARK GREEN
penswater_night:
  defb 4  ;0  TRANSPARENT/BACKGROUND
  defb 25 ;1  WHITE
  defb 0  ;2  BLACK
  defb 0  ;3  BROWN
  defb 3  ;4  RED
  defb 3  ;5  BLUE
  defb 14 ;6  YELLOW
  defb 4  ;7  ORANGE
  defb 0  ;8  PURPLE
  defb 14 ;9  LIGHT BLUE
  defb 4  ;10 MEDIUM BLUE
  defb 12 ;11 LIGHT GREEN
  defb 10 ;12 SEA GREEN
  defb 9  ;13 TEAL
  defb 2  ;14 MAUVE
  defb 0  ;15 DARK GREEN
endif