; ASIC PAGED IN 4000-7FFF
; SCREEN RAM    8000-BFFF
; ROM PAGED IN  C000-FFFF

; CALL COMMAND DOESN'T WORK FROM BASIC ONCE PROGRAM CODE GOES OVER &AC00


;compilemainbinary equ 1
;is128k equ 1
compilecart equ 1
;isplus equ 1
isinter equ 1 ; ENABLE INTERRUPTS - NOT USABLE IF WE HAVE NO FIRMWARE E.G. CARTRIDGE???
;isnicemusic equ 1	
;isoldmusic equ 1
;rasm equ 1
;debugtime equ 1

ifdef compilecart
  iscart equ 1
  isplus equ 1
  isrom  equ 1
  rasm equ 1
endif

; USE THIS CODE TO ASSEMBLE IN BASIC FOR 128k VERSION
; THEN
; SAVE "QUEST128.BIN",b,&0e00,&76b0 (or whatever the length is in ram)
;
; 64K - NEEDS SPLIT IN TWO BLOCKS
; SAVE "QUEST.BIN",b,&0e00,&9200
; SAVE "QUEST2.BIN",b,&A000,&0900

; MEMORY BANKS LAYOUT FOR 128K
;
; BANK 4 = TILES   - ONLY SWAPPED IN FOR SCREEN REDRAW / TILE REDRAW
; BANK 5 = SPRITES - ONLY SWAPPED IN FOR SCREEN GENERATION
; BANK 6 = DICT    - TEXT STRINGS FOR CHARACTERS
; BANK 7


; MIMO'S QUEST
; ============

; IDEAS
; =====

; SAVE GAMES? PASSWORD TO STORE MONEY, INVENTORY, QUESTS, LOCATION?
; -----------------------------------------------------------------

; CONVERSATIONS RANDOMLY BUILT FROM WORD BANKS
; --------------------------------------------

;   "WATCH OUT FOR"          "PESKY"   "RABBITS"   "ARE NICE"          "AFTER A MEAL"
;   "BE CAREFUL OF"          "LARGE"   "PEARS"     "ARE NO GOOD"       "TO EAT"
;   "SOME PEOPLE THINK THAT" "TINY"    "BANANAS"   "ARE VERY NICE"     "THIS TIME OF YEAR"
;   "I HEAR THAT"            "GREAT"   "FLOWERS"   "ARE NOT SO NICE"   "IN THE SPRING"
;   "SOME SAY"               "RED"     "BIRDS"     "ARE GREAT"         "AT NIGHT"
;   "A WISE MAN SAID"        "BLUE"    "BERRIES"   "ARE TASTY"         "BEFORE SUPPER"
 
; CONVERSATIONS BASED ON SEASON, LOCATION 
; ---------------------------------------

; MARRIAGE
; --------
;   GIVE GIFTS TO GIRL, ANSWER QUESTIONS TO SHOW COMPATIBILITY, BUY HOUSE
;   HARVEST FESTIVAL 
;   POSSIBLY HAVE LOTS OF RANDOM GIRLS, AND TABLE OF GIRLS COMPATIBILITY
;   THAT CAN BE OVERWRITTEN IF NEEDED?

; COMPLETED QUESTS IMPROVE REPUTATION?
; ------------------------------------
;
;   DOING QUEST FOR INDIANS GAINS INDIAN REP
;   DOING QUEST FOR COWBOYS GAINS COWBOY REP
;   ARROW CAN DO DAMAGE TO PEOPLE? DESTROY REP?

; BUILDINGS
; ---------
;   BANK
;   JAIL
;   LUMBER
;
; BANK LOANS?
; 

;; width of a tile
tile_width equ 8
tile_width_bytes equ tile_width/2
font_width_bytes equ 4/2
;; height of a tile
tile_height equ 16
font_height equ 5
;; number of bytes used by tile (each tile uses same 
;; number of bytes and stored uncompressed in a formmn
;; that can be poked direct to screen)
tile_data_size equ tile_width_bytes*tile_height
font_data_size equ font_width_bytes*font_height

;ScreenSize equ &4000
;; width of screen in pixels
scr_width_pixels         equ tile_width*20
;scr_right_side equ scr_width_pixels-4
;; height of screen in pixels
scr_height_pixels        equ tile_height*10
scr_width_bytes          equ scr_width_pixels/2

scr_width_bytes_right    equ scr_width_bytes-4
scr_height_pixels_bottom equ scr_height_pixels-16

;; width of screen in tiles
tilemap_width_tiles      equ scr_width_bytes/tile_width_bytes
;; height of screen in tiles
tilemap_height_tiles     equ scr_height_pixels/tile_height
tilemap_total_tiles      equ tilemap_width_tiles*tilemap_height_tiles
tilemap_win_tiles        equ tilemap_width_tiles*tilemap_height_tiles

;; firmware functions we use

ifndef iscart
   scr_set_mode     equ &bc0e
   kl_u_rom_disable equ &B903
endif
scr_set_border  equ &bc38
ifndef isplus
   scr_set_ink  equ &bc32
endif

ifdef rasm
  defs 3584 ; BRING US UP TO 0E00 WITH 0s
endif
org &0E00


nolist

jp start

read "datadefs.asm"                ; MEMORY ADDRESSES DEFINITIONS FOR VARIABLES

ifdef iscart
  ; READ CODE MODULES
  read "reusablecode.asm"           ; CODE THAT ONLY NEEDS TO BE RUN ONCE - SO IT CAN BE ERASED AND USED FOR OTHER THINGS BY DATA BLOCKS
  read "bankswitchcode.asm"         ; CODE FOR BANK SWITCHING AND LOADING TILE GRAPHICS - MUST NOT BE IN RANGE $4000-7FFF
  ; MISC
  read "speedup.asm"                ; MISC ASM SPEED UP          - MUST NOT BE IN RANGE $4000-7FFF
  read "data.asm"                   ; INITIALIZATION DATA

  ; GRAPHICS
  read "graphics3.asm"              ; MISC GRAPHICS FUNCTIONS    - MUST NOT BE IN RANGE $4000-7FFF (ASIC GETS PAGED IN HERE)
  read "tilemapdraw2.asm"           ; SPRITE GRAPHICS            - MUST NOT BE IN RANGE $4000-7FFF
  read "populatetilemap128k7.asm"   ; PROCEDURAL MAP GENERATION  - MUST NOT BE IN RANGE $4000-7FFF
  read "populaterooms4.asm"         ; PROCEDURAL ROOM GENERATION - MUST NOT BE IN RANGE $4000-7FFF
  read "quests4.asm"                ; QUEST DATA                 - MUST NOT BE IN RANGE $4000-7FFF
  read "mazedata.asm"               ; STATIC ROOM GENERATION     - MUST NOT BE IN RANGE $4000-7FFF
  ; WORLD GENERATION
  read "pseudorandom3.asm"          ; PSUEDO RANDOM GENERATOR    - MUST NOT BE IN RANGE $4000-7FFF
  read "zonedefs4.asm"              ; ZONE DEFINITION TABLES     - MUST NOT BE IN RANGE $4000-7FFF
  read "randomquests4.asm"          ; RANDOM QUEST DATA          - MUST NOT BE IN RANGE $4000-7FFF

  ; ...ABOUT &3D90

  ; ---------------------------------------------------------------------------------------------

  read "generatetiles128k.asm"      ; MODIFY GRASS ETC
  read "tilegraphicssprite.asm"     ; SPRITE GRAPHICS FOR MIMO
  read "tilegraphicsletters.asm"    ; SPRITE GRAPHICS FOR LETTERS

  read "statusbar4.asm"             ; STATUS BAR RENDERING
  read "discoveredtowns.asm"        ; FOR KEEPING A LIST OF LOCAL TOWNS PLAYER CAN DO QUESTS AT

  read "definitions.asm"            ; DEFINITIONS FOR 64k OR 128k
  read "spritegraphics4_defs.asm"  
  read "spritemovement128k2.asm"    ; SPRITE MOVEMENT ROUTINES

  ; SPRITE MOVEMENT
  read "ExampleKeyboard2.asm"       ; JOYSTICK READING CODE
  read "collision.asm"              ; SPRITE MOVEMENT ROUTINES
  read "spritemask.asm"             ; SPRITE MASK ROUTINE
  read "gengamemap.asm"             ; GENERATE GAME MAP
  read "seamaps.asm"                ; GENERATE INDIVIDUAL MAP SQUARES

  read "daynight2.asm"              ; CONTROL DAY AND NIGHT PALETTE
  read "treedamage4.asm"            ; FOR RECORDING DAMAGE TO TREES WITH AXE
  ; CHARACTER INTERACTION
  ;read "dictionary_128k.asm"        ; DICTIONARY OF WORDS DEFINITIONS
  stringstable equ &C000              ; DON'T READ, JUST POINT TO WHERE "dictionarystrings.asm" WILL BE
    read "dictionary.asm"               ; DICTIONARY
    read "dictionarydefs.asm"           ; DEFINITIONS FOR 64k OR 128k
    read "dictionarystringsdefs.asm"    ; DICTIONARY OF WORDS

  read "inventory2.asm"              ; INVENTORY CODE
  read "sailingship.asm"            ; BOAT FUNCTIONS
  read "shop.asm"                   ; SHOP CODE
  read "aiconversations.asm"        ; STORY LINE DATA
  read "wantedposter.asm"           ; BOUNTY HUNTER DATA
  read "saloongame.asm"             ; PLAY SALOON GAME
  read "saloonbarman.asm"           ; SALOON BAR MAN
  read "minister.asm"               ; CHURCH MINISTER INTERACTION
  ; SOUND
  read "sounday2.asm"               ; SOUND EFFECTS
  read "turretfire.asm"             ; TURRET FIRE
endif

ifndef iscart
  read "definitions.asm"            ; DEFINITIONS FOR 64k OR 128k
  read "spritegraphics4_defs.asm"  
  read "reusablecode.asm"           ; CODE THAT ONLY NEEDS TO BE RUN ONCE - SO IT CAN BE ERASED AND USED FOR OTHER THINGS BY DATA BLOCKS
  ; READ CODE MODULES
  ; MEMORY
  ; BELOW CODE MUST NOT BE IN RANGE &4000-&7FFF

  read "bankswitchcode.asm"         ; CODE FOR BANK SWITCHING AND LOADING TILE GRAPHICS - MUST NOT BE IN RANGE $4000-7FFF

  ; MISC
  read "speedup.asm"                ; MISC ASM SPEED UP          - MUST NOT BE IN RANGE $4000-7FFF
  read "data.asm"                   ; INITIALIZATION DATA

  ; GRAPHICS
  read "tilemapdraw2.asm"           ; SPRITE GRAPHICS            - MUST NOT BE IN RANGE $4000-7FFF
  read "populatetilemap128k7.asm"   ; PROCEDURAL MAP GENERATION  - MUST NOT BE IN RANGE $4000-7FFF
  read "populaterooms4.asm"         ; PROCEDURAL ROOM GENERATION - MUST NOT BE IN RANGE $4000-7FFF
  read "quests4.asm"                ; QUEST DATA                 - MUST NOT BE IN RANGE $4000-7FFF
  ;read "wife.asm"                  ; WIFE INTERACTION           - MUST NOT BE IN RANGE $4000-7FFF
  read "mazedata.asm"               ; STATIC ROOM GENERATION     - MUST NOT BE IN RANGE $4000-7FFF
  ; WORLD GENERATION
  read "pseudorandom3.asm"          ; PSUEDO RANDOM GENERATOR    - MUST NOT BE IN RANGE $4000-7FFF
  read "zonedefs4.asm"              ; ZONE DEFINITION TABLES     - MUST NOT BE IN RANGE $4000-7FFF
  read "randomquests4.asm"          ; RANDOM QUEST DATA          - MUST NOT BE IN RANGE $4000-7FFF
  read "graphics3.asm"              ; MISC GRAPHICS FUNCTIONS    - MUST NOT BE IN RANGE $4000-7FFF

  ; -----------------------------------------------------------------------------------------------

  read "generatetiles128k.asm"      ; MODIFY GRASS ETC
  read "tilegraphicssprite.asm"     ; SPRITE GRAPHICS FOR MIMO
  read "tilegraphicsletters.asm"    ; SPRITE GRAPHICS FOR LETTERS

  read "spritegraphics4_128k.asm"   ; SPRITE DATA
  read "tilegraphicsmain128k.asm"   ; SPRITE DATA
  ; 128k BANKSWITCHING NOTE - 4000 STARTS AROUND HERE NOW!!! BELOW CODE MUST NOT BE ESSENTIAL FOR GENERATING/DRAWING SCREEN

  read "spritemovement128k2.asm"    ; SPRITE MOVEMENT ROUTINES

  ; SPRITE MOVEMENT
  read "ExampleKeyboard2.asm"       ; JOYSTICK READING CODE
  read "collision.asm"              ; SPRITE MOVEMENT ROUTINES
  read "spritemask.asm"             ; SPRITE MASK ROUTINE
  read "gengamemap.asm"             ; GENERATE GAME MAP
  read "seamaps.asm"                ; GENERATE INDIVIDUAL MAP SQUARES 

  read "daynight2.asm"              ; CONTROL DAY AND NIGHT PALETTE
  read "treedamage4.asm"            ; FOR RECORDING DAMAGE TO TREES WITH AXE
  ; CHARACTER INTERACTION
  read "dictionary_128k.asm"        ; DICTIONARY OF WORDS

  read "inventory2.asm"              ; INVENTORY CODE
  read "sailingship.asm"            ; BOAT FUNCTIONS
  read "shop.asm"                   ; SHOP CODE
  read "aiconversations.asm"        ; STORY LINE DATA
  read "wantedposter.asm"           ; BOUNTY HUNTER DATA
  read "saloongame.asm"             ; PLAY SALOON GAME
  read "saloonbarman.asm"           ; SALOON BAR MAN
  read "minister.asm"               ; CHURCH MINISTER INTERACTION

  ; SOUND
  read "sounday2.asm"               ; SOUND EFFECTS
  read "turretfire.asm"             ; TURRET FIRE
  
  ; 128k BANKSWITCHING NOTE - FOLLOWING CODE IS ESSENTIAL FOR DRAWING SCREEN. MUST NOT BE IN &4000-7FFF
  ; (WE SWAP &4000-&7FFF WITH EXTRA BANKS 1-4)
  ifdef is128k
    org &8000
    ; ------------------------------------------------------------------------------ 
  endif

  read "statusbar4.asm"             ; STATUS BAR RENDERING
  read "discoveredtowns.asm"        ; FOR KEEPING A LIST OF LOCAL TOWNS PLAYER CAN DO QUESTS AT
  ;read "genmap-showmap.asm"
endif

; SEQUENCE TO UNLOCK THE PLUS FEATURES
; THIS SHOULD BE DONE BY LOADER / CART BOOT CODE
; BUT WE NEED TO RUN IT HERE WHEN WE COMPILE OUR CODE IN WINAPE

ifdef isplus
ifndef iscart
;; sequence to unlock asic
sequence: defb &ff,&00,&ff,&77,&b3,&51,&a8,&d4,&62,&39,&9c,&46,&2b,&15,&8a,&cd,&ee
endif
endif

; -----------------------------------------------------------------
; END OF CODE AROUND $7200 SO FAR

restartgame:
  ld l,s_str_restartgame
  call getstringhl
  call askyesnoplayer
  cp "n"
  ret z
  jr mainloop1

start:
ifdef isplus
ifndef iscart
  ; SET INTERRUPT FUNCTION - STOPS BASIC RE-LOCKING ASIC
  ld a,&c9 ;(RET)
  ld hl,&0038
  ld (hl),a

  ;ifndef iscart
  ;; unlock ASIC so we can access ASIC registers
  di
  ld b,&bc
  ld hl,sequence
  ld e,17
  seq:
    ld a,(hl)
    out (c),a
    inc hl
    dec e
  jr nz,seq
  ei

  ; SET PALETTE
  ld hl,pens
  call dopens 
 endif
endif

  call createlookuptables
  call detectram
  ; WIPE REUSABLE DATA AREA &0E00 TO &0FFF
  ;ld hl,letters_ptr_table
  ;ld bc,4032 ; CLEAR FROM &0040 TO &1000
  ;call clearmem

ifndef iscart
   call kl_u_rom_disable ; DISABLE UPPER ROM SO WE CAN USE IT FOR THE GAME SPACE
endif

ld l,s_str_intro
call statusbarprintparagraphhl;noscroll
; DISPLAY LOADING SCREEN UNTIL USER PRESSES BUTTON
call waitspace 


mainloop1:
  ; INITIATE DATA AREAS OF MEMORY, STRINGS, ETC
  call initiatevars

  ; GENERATE TILEMAP
  call marktilemapchanged

;; the main loop which draws and updates sprite

main_loop:
;  call displaywholemap
;  loopita
;  jr loopita
  ;; check keys and update sprite position
  call check_keys

  ; SELF MODIFY - "CALL check_tilemap" WHEN TILEMAP CHANGES
  ; AFTER CALL COMPLETES, THIS CALL GETS CHANGED BACK TO 3 x NOPs.
  ; THIS SAVES A LOT OF PROCESSING POWER AS WE DON'T HAVE TO KEEP CHECKING A VARIABLE
  ; EACH TIME TO SEE IF ANYTHING HAS CHANGED.
  defb &CD           :tilemapcallfunc         ; &CD = CALL 
  defw check_tilemap :tilemapchangedfunc      ; = check_tilemap

  ; UPDATE ARROWS IN MAIN ROUTINE AS IT NEEDS TO MOVE FAST
  call updatecharacterspritesarrow

  ; FIRST INTERRUPT HANDLER
  ld a,10:interuptcounter_plus1
  dec a
  ld (interuptcounter_plus1-1),a
  or a
  jr nz,main_loop
  ld a,10
  ld (interuptcounter_plus1-1),a

  ; UPDATE SPRITE CHARACTERS IN SUB ROUTINE AS THEY NEED TO MOVE SLOW
  ; LOAD CHARACTER TABLE DATA
  call sounddurationevent
  call updatecharactersprites

  defb &CD             :tileanimcallfunc         ; &CD = CALL 
  defw updatetileanims :tileanimchangedfunc      ; = updatetileanims

  ; SECOND INTERRUPT HANDLER IS SLOWER THAN FIRST ONE - UPDATES EVERY SECOND

  ld a,10:interuptcounter2_plus1
  dec a
  ld (interuptcounter2_plus1-1),a
  or a
  jr nz,main_loop
  ld a,5;255;5;10;255;5
  ld (interuptcounter2_plus1-1),a

  ld a,(time)
  inc a
  ld (time),a

  defb &CD                 :timecallfunc         ; &CD = CALL 
  defw updatestatusbartime :timechangedfunc      ; = updatestatusbartime

jr main_loop

list
defb "CHRIS2"

; AUTOMATICALLY SAVE THE COMPILED CODE TO DSK
; START, LENGTH, EXEC ADDRESS

ifndef rasm
ifdef compilemainbinary
  ifdef is128k
    save direct "QUEST128.BIN",&0e00,&7710;84F0
  endif
  ifndef is128k
    ; NEEDS SAVED IN TWO PARTS. TAPE CAN ONLY LOAD MAX 16K
    save direct "QUEST.BIN",&0e00,&9200
    save direct "QUEST2.BIN",&a000,&0E90
  endif
endif
ifdef compilecart
  ifdef iscart
    save "game_mimo_aa",&0000,&4000
    save "game_mimo_ab",&4000,&4000
  endif
endif
endif