;Reg 	Meaning 			Bit Meaning 	Details
;0 	Tone Pitch L - Channel A 	LLLLLLLL 	Lower value = Higher pitch
;1 	Tone Pitch H - Channel A 	----HHHH 	Lower value = Higher pitch
;2 	Tone Pitch L - Channel B 	LLLLLLLL 	Lower value = Higher pitch
;3 	Tone Pitch H - Channel B 	----HHHH 	Lower value = Higher pitch
;4 	Tone Pitch L - Channel C 	LLLLLLLL 	Lower value = Higher pitch
;5 	Tone Pitch H - Channel C 	----HHHH 	Lower value = Higher pitch
;6 	Noise Generator 		---NNNNN 	Higher = Faster noise
;7 	Mixer  				--NNNTTT   	N=Noise T=Tone (Channel --CBACBA 1=mute 0=normal)
;8 	Amplitude - Channel A 		---EVVVV 	E=Envelope (1=Enabled) VVVV=Volume
;9 	Amplitude - Channel B 		---EVVVV 	E=Envelope (1=Enabled) VVVV=Volume
;10 	Amplitude - Channel C	 	---EVVVV 	E=Envelope (1=Enabled) VVVV=Volume
;11 	Envelope L (Volume over time)  	LLLLLLLL 	Lower=Faster Envelope
;12 	Envelope H (Volume over time)  	HHHHHHHH 	Lower=Faster Envelope
;13 	Envelope Selection 		----EEEH 	E=Envelope number E (See PDF) H=Hold



org &4000
jp start

table:
  defb %01100001
  defb %01100010 
  defb %01100100
  defb %01101000
  defb %01110000
  defb %01100011
  defb %01101100
  defb %01111000
  defb %01101100
  defb %01100011
  defb %01101111
  defb %01111111
  defb %00000000
  defb 255

start:
  ld a,7           ; SET MIXER
  ld c,%10111110   ; %PPNNNTTT (1=off) --CBACBA PP=PORTS
  call RegWrite

  xor a
  ld c,%00111111    ; TONE - LOWER 8 BITS - CHANNEL A
  call RegWrite
  ld a,1
  ld c,%00000000    ; TONE - UPPER 4 BITS
  call RegWrite
  


  ld a,13			;SELECT ENVELOPE ----EEEH
  ld c,%00000010
  call RegWrite
  
  ld a,11			;Envelop LLLLLLLL
  ld c,%01001111
  call RegWrite
  ld a,12			;Envelop HHHHHHHH
  ld c,%00000100
  call RegWrite


  ld a,8            ; VOLUME / ENVELOPE FOR CHANNEL A ---EVVVV
  ld c,%00011111    ; E=1 MEANS ENVELOPE ON
  call RegWrite

ret




  call AYSetEnv
  call AYSelectEnv
  call AYSetAmpA

  ; NVPPPPP
  ld hl,table
  loopy:
    ld a,(hl)
    cp 255
    ret z
    push hl
    ;ld a,%00100111
    call ChibiSound

    ld b,255
    delay:
      ld a,"D"
      push bc
      call &bb5d
      pop bc
    djnz delay
    ld a," "
    call &bb5d
    pop hl
    inc hl
  jr loopy
ret

; INPUT
AYSetEnv:
	ld a,11			;Envelop LLLLLLLL
	ld c,%01001111
	call RegWrite
	ld a,12			;Envelop HHHHHHHH
	ld c,%00100000
	call RegWrite
ret	

AYSelectEnv:
	ld a,13			;SELECT ENVELOPE ----EEEH
	ld c,%00000010
	call RegWrite
ret	


AYSetAmpA:
	ld a,8			;SET ENVELOPE ---EVVVV 	E=Envelope (1=Enabled) VVVV=Volume
	ld c,%00011111
	call RegWrite
ret	

ChibiSound:			;NVVTTTTT	Noise Volume Tone 
	or a
	jr z,silent
	
	ld h,a
	and %00000111
	rrca
	rrca
	rrca
	or %00011111
	ld c,a
	ld a,0			;TTTTTTTT Tone Lower 8 bits	A
	call RegWrite

	ld a,h
	and %00111000
	rrca
	rrca
	rrca
	ld c,a
	ld a,1			;----TTTT Tone Upper 4 bits
	call RegWrite
	bit 7,h
	jr z,AYNoNoise

	;ld a,7			;Mixer  --NNNTTT (1=off) --CBACBA
	;ld c,%00110110
	;call RegWrite

	;ld a,6			;Noise ---NNNNN
	;ld c,%00011111
	;call RegWrite


	jr AYMakeTone
AYNoNoise:
	ld a,7			;Mixer  --NNNTTT (1=off) --CBACBA
	ld c,%00111110
	call RegWrite
	jr AYMakeTone
AYMakeTone:
	;*** these are incorrectly marked as Amplitude Control (Registers R10,R11,R12) in some documentation! ***
	ld a,h
	and %01000000
	rrca
	rrca
	rrca
	rrca
	or  %00001011
	ld c,a
	ld a,8			;4-bit Volume / 2-bit Envelope Select for channel A ---EVVVV
	call RegWrite
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
silent:
	ld a,7		;Mixer  --NNNTTT (1=off) --CBACBA
	ld c,%00111111
	call RegWrite
	

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RegWrite:
	push bc
		ld b,&f4
		ld c,a
		out (c),c	;#f4 Regnum

		ld bc,&F6C0	;Select REG
		out (c),c	

		ld bc,&f600	;Inactive
		out (c),c

		ld bc,&F680	;Write VALUE
		out (c),c	
	pop bc
 	ld b,&F4	;#f4 value
	out (c),c

	ld bc,&f600	;; "inactive"
	out (c),c
	ret



