statusbar_iconpos equ screenadr+&36E4
space_iconpos     equ statusbar_iconpos+40+40
space_seasonpos   equ screenadr+&3EE4
space_seasonpos2  equ space_seasonpos+10

;str_temp    defb "                            ",255 ; SIZE 28 + EOL (END IN 255)
screentext4: defb "                            ",255
; SIZE 28 + EOL (END IN 255) - NEED OVERRUN BUFFER FOR WORDWRAP HERE SO DOUBLE THIS

str_menu: defb "INVENTORY",10,"STORY ",13,quest,"S",10,"OTHER ",13,quest,"S",10,"RESTART GAME",10,"EXI","T"+&80;,255

menufunctions:
  defw showinventoryactivateitem        ; 0 
  defw showgamequests                   ; 1
  defw showrandomquests                 ; 2 
  defw restartgame                      ; 5
  defw 0                                ; EXIT MENU = 5
  ;defw newrandomseed                   ; MAKE RANDOM SEED = 6

showinventoryactivateitem:
  call showinventory
  jp setactiveitem

;newrandomseed
;  call createnewrandomseed
;  call genlocalgamemaps ; REGENERATE LOCAL MAP IN CASE WE CHANGED SEED
;  jp restartgame

showmenu:
  ld hl,str_menu
  call statusbarprintparagraph
  ld a,5
  call waitoption_1_2_3_4_5ss
  cp 4
  jr z,clearmenu
  ld hl,menufunctions
  jp vectortablelaunchcode
  
;dotogglemap
;  call togglemap
  clearmenu:
  ld a,255
  ld (linecount),a
  jp scrolltopofpage
  
;wordtostr  defb "00000"

; CONVERT A 16 BIT HEX TO STRING - EG FOR PLAYER MONEY
; INPUTS
; HL = NUMBER TO CONVERT
convwordtostr:
  ld bc,10000
  call convwordtostrloop
  ld (wordtostr+0),a  ; SAVE RESULT IN STRING
  ld bc,1000
  call convwordtostrloop
  ld (wordtostr+1),a  ; SAVE RESULT IN STRING
  ld bc,100
  call convwordtostrloop
  ld (wordtostr+2),a  ; SAVE RESULT IN STRING
  ld bc,10
  call convwordtostrloop
  ld (wordtostr+3),a  ; SAVE RESULT IN STRING
  ld a,l
  add 48
  ld (wordtostr+4),a  ; SAVE RESULT IN STRING
ret

; INPUTS
; BC = TENS HUNDREDS UNIT TO CHECK FOR
convwordtostrloop:
  xor a      ; RESET COUNTER
  convwordtostrloop2:
    sbc hl,bc
    inc a
  jr nc,convwordtostrloop2
  add hl,bc
  dec a
  add 48               ; CONVERT TO ASCII
ret

; VARIOUS FUNCTIONS
; CONVERT TENS AND HUNDREDS INTEGER OF BYTE TO STRING
; INPUTS
; C = AMOUNT TO CHECK, EITHER 10 OR 100
convbytetenshundreds:
  ld b,255
  hundredsloop:
    sub c
    inc b
  jr nc,hundredsloop
  add c
  ; WRITE TO MEMORY / ADD 48 TO CONVERT FROM DECIMAL TO CHAR
  ld d,a
  ld a,b
  add 48
  ld (hl),a
  inc hl
  ld a,d
ret
; CONVERT BYTE TO INTEGER STRING
; A = BYTE TO CONVERT
; RESULT LOADED INTO BYTETOSTRING

convbytetostr:
  push hl
  push de ; BACK UP D
  ld hl,bytetostring

  ; HUNDREDS
  ld c,100
  call convbytetenshundreds
  ld c,10
  call convbytetenshundreds

  ; SINGLES
  add 48
  ld (hl),a  

  pop de
  pop hl
ret

; CONVERT 001 TO 1 FOR SHOP PRICES
raligncoord:
  ld hl,bytetostring
  ld a,(hl)
  cp "0"
  ret nz
  inc hl
  ld a,(hl)
  cp "0"
  jr z,justsingles
  dec hl
  ld (hl),a
  ld a,(bytetostring+2)
  inc hl
  finishendofcoord:
  ld (hl),a
  inc hl
  ld (hl),255
ret

justsingles:
  inc hl
  ld a,(hl)
  dec hl
  dec hl
  jr finishendofcoord

;bytetostring defb "000",255

; UPDATE STATUS BAR ICON INVENTORY
; INPUTS
; B = TILEMAP NUMBER OF ICON TO DISPLAY
;updatestatusbaricon
;  ; CLEAR AREA FIRST
;  call clearstatusbaricon
;  push hl
;  push bc ; BACKUP B
;  ; DRAW ICON WE PICKED UP
;  ld a,b
;  ld de,tile_ptr_table
;  dec a ; MAKE TILES START FROM 1
;  call get_tile_ptr    ;; lookup ptr to tile pixels
;  ld hl,statusbar_iconpos
;  call tile_draw    ;; now draw tile  
;  pop bc
;  pop hl
;ret

genmoneystring:
  ; X COORD
  ld hl,(player_cash2)
  call convwordtostr
  ld hl,wordtostr
  
  ld a,"0"
  ld (tilemap_name3+1),a
  ld de,tilemap_name3+2 ; SKIP DOLLAR SIGN
  ldi
  ldi
  jr finishgenstring

gencoordstr:
  ; X COORD
  ld a,(tilemap_cur)
  call convbytetostr
  ld hl,bytetostring
  ld de,tilemap_name
  ldi
  ldi 
  ldi
  ; PERIOD
  ld a,":"
  ld (de),a
  inc de
  ; Y COORD
  ld a,(tilemap_cury)
  call convbytetostr
  ld hl,bytetostring
  finishgenstring:
  ldi
  ldi
  ldi
ret

; DRAW HORIZONTAL LINE ALL WAY ACROSS SCREEN
; INPUTS
; HL = SCREEN MEMORY LOCATION
; A = LINE COLOUR
; A PRESERVED
DrawHorizLine:
  push af
  push hl
  ld (hl),a ; LINE COL
  push hl ; COPY HL TO DE
  pop de 
  inc e
  call useLDI79
  pop hl
  call scr_next_line_hl
  pop af
ret

DrawHorizLineTextBar:
  push af
  push hl
  ld (hl),&C0 ; LINE COL WHITE
  push hl ; COPY HL TO DE
  pop de 
  inc e
  call useLDI20
  call useLDI20
  call useLDI10
  call useLDI5
  pop hl
  call scr_next_line_hl
  pop af
ret

ClearStatusBar:
  ld hl,screenadr+1600
  ld a,&0C
  call DrawHorizLine
  ld a,&30 ; RED LINE
  call DrawHorizLine
  ld a,&68 ; YELLOW LINE
  call DrawHorizLine
  ld a,&C0 ; WHITE LINE
  call drawhoriz4
  call drawhoriz32
  ld a,&30 ; RED
  jp DrawHorizLine

drawstatusbar:
  ld hl,screenadr+1600+80-3
  ld de,scrollright2
  call tile_restore_scroll2
  ld hl,screenadr+1600
  ld de,scrollleft
  jp tile_restore_scroll

updatestatusbar:
  ld hl,screenadr+1600+80+4
  push de
  ld de,tilemap_name
  call gra_wr_string2
  pop de
updatestatusbarmoney:
  call genmoneystring
  ld hl,screenadr+1600+160+4
  push de
  ld de,tilemap_name3
  ; INPUTS 
  ; DE = STRING TO WRITE TO STATUS BAR
  dowritestring:
  call gra_wr_string2
  ;call updatestatusbartime
  pop de
ret

;updatestatusbartext
;  ld hl,screenadr+1600+320+20
;  push de
;  ld de,screentext4
;  jr dowritestring

statusbarscrollnewline:
  push de
  push hl
  push bc

  ;call updatestatusbartext

  ld de,topstatusbarline     ; TOP STRING
  ld hl,secondstatusbarline  ; BOTTOM STRING
  ld b,24                    ; ROWS OF PIXELS TO COPY
  loopyman: 
    push bc ; PRESERVE COUNT

    push hl
    push de
    call useLDI28
    call useLDI28
    pop de
    pop hl
    call scr_next_line_hl
    ex de,hl
    call scr_next_line_hl
    ex de,hl

    pop bc
  djnz loopyman
  ;call clearnewline        ; ERASE STATUS BAR STRING WITH SPACES
  ;call updatestatusbartext ; DRAW SPACES ON SCREEN IN CASE NEXT LINE DOES NOT REACH TO END, I.E WORDWRAPPED

  ; CLEAR NEW LINE
  ld hl,screenadr+1600+320+20
  call DrawHorizLineTextBar
  call DrawHorizLineTextBar
  call DrawHorizLineTextBar
  call DrawHorizLineTextBar
  call DrawHorizLineTextBar
  call DrawHorizLineTextBar

  pop bc
  pop hl
  pop de
ret

underlinenewline:
  ld a,"-"
  ld h,d
  ld l,e
  ld (hl),a
  inc de
  jp useLDI27

; GET STRING INTO HL FOR PRINTING ON STATUS BAR
; IF 128K, THIS COMES FROM BANK 3. WE COPY IT TO A SPARE MEMORY LOCATION
; AND BANKSWITCH BACK TO NORMAL

; INPUTS
; L = STRING NUMBER TO LOOK UP IN TABLE

; OUTPUTS
; HL = POINTER TO STRING TO PRINT
; DE PRESERVED
; A PRESERVED
getstringhl:
  push af

  ; BANK SWITCH TO DICT
ifdef is128k
  ld a,&C6
  ld b,&7F
  out (c),a
endif
ifdef iscart
  call romswitchdict
endif

  ; LOOK UP STRINGS TABLE AND COPY STRING TO SPARE RAM
  ld a,l
  ld hl,stringstable
  call vectorlookuphl
 
  push de
  ld de,str_temp3 ; COPY STRING IN BANK TO SPARE MEMORY LOCATION
  call copystr4;2    ; COPY STRING AND 255 MARKER
  ld hl,str_temp3 ; POINT HL TO STRING IN NORMAL MEMORY
  pop de

  ; BANK SWITCH TO NORMAL
ifdef is128k
  ld a,&C0
  ld b,&7F
  out (c),a
endif
ifdef iscart
  call romswitchnormal
endif

 pop af

ret


; WRITE STRING TO BUFFER screentext4
; INPUTS
; HL = LINE OF TEXT TO PRINT
; DE = OBJECT TEXT TO INSERT IN PLACE OF CHAR 11
; A = 1, DO PAGE SCROLL
;str_backup_ptr  defw 0

; SCROLL ANY NEW CHARACTER SPEECHES TO TOP OF PAGE. THIS CLEARS
; THE PAGE OF ANY OLD INFORMATION, MAKES IT LOOK LESS CLUTTERED
scrolltopofpage:
  ld a,(linecount)
  scrollpageloop:
     cp 4
     ret z
     inc a
     push af
     call statusbarscrollnewline
     pop af
  jr scrollpageloop
ret

; INPUT L = STRING TO LOOK UP TO PRINT
statusbarprintparagraphhl:
  call getstringhl
; IF WE REACH 5 LINES, ASK FOR SPACE TO CONTINUE PRINTING
statusbarprintparagraph:
  ld a,1 ; DO SCROLL UP
  jr dostatusbarprintparagraph
statusbarprintparagraphnoscroll:
  xor a
dostatusbarprintparagraph:
  push af                ; STORE WHETHER WE DO PAGE SCROLL
  push bc
  ld (str_backup_ptr),de ; BACKUP INSERT TEXT (OBJECT STR)

  ; RESET LINE COUNT
  ld a,255
  ;xor a
  ld (linecount),a

  statusbarprintpara:
  ;call statusbarscrollnewline
  ld de,str_temp2;screentext4
  ;ld (spacecounthl),hl   ; RESET LAST SPACE POS
  ;ld (spacecountde),de   ; RESET LAST SPACE POS

  printloop:
    ld a,(hl)
    sub 22
    jr nc,isnotcode
    add 12
    or a;cp 10 ; MAKE NEW LINE
    jr z,printloopjustcopychar
    dec a;cp 11 ; PRINT OBJECT TEXT
    jr z,printobjecttext
    dec a;cp 12 ; PRINT UNDERLINE
    jr z,makeunderline
    dec a;cp 13 ; PRINT DICTIONARY WORD
    jp z,printdictionaryword
    dec a;cp 14 ; PRINT COORDINATE AS TEXT
    jp z,printcoord
    dec a;cp 15 ; PRINT CURRENT TOWN NAME
    jp z,printtownname
    dec a;cp 16 ; PRINT DESTINATION TOWN NAME BY 2 BYTE COORDINATES
    jp z,printtownname2
    dec a;cp 17 ; PRINT 16BIT NUMBER AS TEXT
    jp z,print16bitnumber
    dec a;cp 18 ; PRINT ADJECTIVE FOOD
    jp z,printadjectivefood
    dec a;cp 19 ; PRINT ADJECTIVE TOOL
    jp z,printadjectivetool
    dec a;cp 20 ; PRINT ADJECTIVE
    jp z,printadjective 
    dec a;cp 21 ; PRINT WANTED MAN NAME FROM NIBBLES
    jp z,printwantedmanname
    isnotcode:
    add 22
    bit 7,a
    jp nz,finishtextprint_bit7
    ;cp 255 ; WE MUST ALWAYS END BEFORE 28 CHARS
    ;jp z,finishtextprint
    ;cp " "; RECORD SPACE POS
    ;jr z,recordlastspace

    ; COPY CHAR
    printloopjustcopychar:
    ldi
  jr printloop
  
  makeunderline:
    inc hl
    push hl
    call underlinenewline
    pop hl
    jp printloop

  ; PRINT OBJECT TEXT
  ; INSERT TEXT INTO STRING
  ; HL = TEXT TO INSERT (ENDING IN 255)
  ; DE = MAIN STRING TO INSERT INTO
  printobjecttext:
    ex de,hl
    ld (hl)," "
    ex de,hl
    inc de ; START WITH SPACE
    inc hl
    push hl ; BACK UP MAIN STRING PTR
    ld hl,(str_backup_ptr)
    jr printstrnew;
    ;call copystr
    ;pop hl
    ;call checkbufferoverrun
    ;jr c,recoverlastspace
    ;jp printloop
  
  printdictionaryword:
    ex de,hl
    ld (hl)," "
    ex de,hl
    inc de ; START WITH SPACE
    ; DE = SCREENTEXT4
    inc hl
    ld a,(hl)           ; GET NUMBER OF WORD TO INSERT
    inc hl
    push hl             ; STORE POS IN STRING TO READ FROM
    ld hl,dictionary
    call vectorlookuphl ; GET WORD INTO HL
    printstrnew:
    call copystr3
    pop hl
    ;call checkbufferoverrun
    ;jr c,recoverlastspace
    jp printloop

  printcoord:
    ; DE = SCREENTEXT4
    inc hl
    ld a,(hl)           ; GET NUMBER OF BYTE TO INSERT
    inc hl
    push hl             ; STORE POS IN STRING TO READ FROM
    call convbytetostr
    call raligncoord
    ld hl,bytetostring
    printstr:
    call copystr
    pop hl
    ;call checkbufferoverrun
    ;jr c,recoverlastspace
    jp printloop

  ; PRINT CURRENT TOWN NAME
  printtownname:
    ex de,hl
    ld (hl)," "
    ex de,hl
    inc de ; START WITH SPACE
    ; DE = SCREENTEXT4
    inc hl
    push hl
    push de
    call resetpseudorandom ; MAKE SURE WE ARE CALCULATING SAME SCREEN NAME EVERY TIME
    printtownnamefunc:
    call genrandomtownname
    call getrandomtownname
    call resetpseudorandom ; MAKE SURE WE ARE CALCULATING SAME SCREEN NAME EVERY TIME
    pop de

    ld hl,str_temp
    jr printstr

  printtownname2:
    ex de,hl
    ld (hl)," "
    ex de,hl
    inc de ; START WITH SPACE
    ; DE = SCREENTEXT4
    inc hl
    push hl
    push de
    call setdesttownseed  ; SET RANDOM SEED TO TOWN LOCATION TO GET CORRECT NAME
    jr printtownnamefunc

  print16bitnumber:
    ; DE = SCREENTEXT4
    inc hl
    ld c,(hl)
    inc hl
    ld b,(hl)
    inc hl
    push hl

    push bc
    pop hl
    call convwordtostr
    ld hl,wordtostr
    jr printstr

  printwantedmanname:
    ; DE = SCREENTEXT4
    inc hl
    ld a,(hl)           ; GET FIRST NAME TO INSERT
    inc hl
    push hl             ; STORE POS IN STRING TO READ FROM
    call getrandomwantedmanname
    ld hl,str_temp
    ld a," "            ; MAKE SPACE BEFORE PRINTING NAME
    ld (de),a
    inc de
    jr printstr

  printadjective:
    ; DE = SCREENTEXT4
    inc hl
    push hl             ; STORE POS IN STRING TO READ FROM
    ld b,numadjectives
    call randmaxnoseed
    ld hl,adjectivedictionary
    printmyword:
    call vectorlookuphl ; GET WORD INTO HL
    jp printstrnew


  printadjectivefood:
    ; DE = SCREENTEXT4
    inc hl
    push hl             ; STORE POS IN STRING TO READ FROM
    ld b,numadjectivesfood
    call randmaxnoseed
    ld hl,adjectivedictionaryfood
    jr printmyword

  printadjectivetool:
    ; DE = SCREENTEXT4
    inc hl
    push hl             ; STORE POS IN STRING TO READ FROM
    ld b,numadjectivestool
    call randmaxnoseed
    ld hl,adjectivedictionarytool
    jr printmyword

  finishtextprint_bit7:
   cp 255  ; NOT SURE WHERE 255 ENDING STRINGS ARE COMING FROM
   jr z,finishtextprint
   res 7,a ; RESET EOL MARKER
   ld (de),a
   inc de
   ;inc hl
   ;inc de

  finishtextprint:
    ;inc de
    ex de,hl
    ld (hl),255              ; MAKE EOL
    ex de,hl

    ld hl,str_temp2
    ld (str_start_ptr),hl ; KEEP RECORD OF WHERE TO START PRINTING THIS LINE FROM
    call printparagraphtoscreen2

    finishtextprint2:
    pop bc
    pop af                   ; RESTORE PAGE SCROLL VARIABLE
    or a
    ret z
    jp scrolltopofpage
    
; ABOVE CODE GENERATES STRING TO PRINT
; BELOW CODE PRINTS IT TO THE SCREEN

str_start_ptr: defw 0
str_end_ptr:   defw 0

; INPUTS
; HL = START OF STRING TO PRINT
printparagraphtoscreen2:
  ; FIND EOL OR FIRST SPACE BEFORE 28 CHARS
  ld b,0
  findeolspace:
    ld a,(hl)
    ;cp 255    ; FOUND EOL
    bit 7,a
    jr nz,foundeol
    cp 10     ; FOUND LF
    jr z,printtolastspace
    inc b
    ld a,b
    cp 29
    jr z,outofspace
    inc hl
  jr findeolspace

; INPUTS
; HL = CURRENT END POSITION OF STR
; B = LEN OF STR TO PRINT
outofspace:
  ; RUN OUT OF ROOM ON STATUS BAR
  ; PRINT UP TO LAST SPACE
  findlastspaceloop:
    ld a,(hl)
    cp " "
    jr z,printtolastspace
    cp "."
    jr z,printtolastspace
    cp "!"
    jr z,printtolastspace
    cp "?"
    jr z,printtolastspace
    dec hl
    dec b
  jr findlastspaceloop

copystrbetweenptrs:
  ld hl,(str_end_ptr)
ifdef iscart
  inc hl     ; DON'T KNOW WHY THIS IS NEEDED - SEEMS TO BE DIFFERENCE BETWEEN CARTRIDGE AND ORDINARY
endif
  ld bc,(str_start_ptr)
  sbc hl,bc
  ld b,h
  ld c,l

  ld a,c ; IN CASE STRING IS ZERO
  or a
  ret z 

  ld hl,(str_start_ptr)
  ld de,screentext4
  push de
  ldir
  ex de,hl
  ld (hl),255
  pop de
ret

printtolastspace:
  ld (str_end_ptr),hl
  call statusbarscrollnewline
  call copystrbetweenptrs
  ld hl,screenadr+1600+320+20
  call gra_wr_string2

  ; UPDATE START PTR TO NEXT PART OF STRING
  ld hl,(str_end_ptr)
  inc hl
  ld (str_start_ptr),hl
  ld (str_end_ptr),hl

  ; INCREASE LINECOUNT
  ld a,(linecount)
  inc a
  ld (linecount),a

  jr printparagraphtoscreen2

foundeol:
  ld (str_end_ptr),hl
  call statusbarscrollnewline
  call copystrbetweenptrs
  ld hl,screenadr+1600+320+20
  call gra_wr_string2

  ; INCREASE LINECOUNT
  ld a,(linecount)
  inc a
  ld (linecount),a

  ret

; INPUTS
; A = CURRENT LINE COUNT
checkreachedendofpage:
   cp 5
   ret nz
   ; RESET LINE COUNT
   xor a
   ld (linecount),a
   push hl ; BACK UP POSITION IN ORIGINAL STRING
   push de ; BACK UP OBJECT WORD
   ; SHOW PRESS SPACE TEXT
   call waitspace
   pop de ; RESTORE OBJECT WORD
   pop hl ; RESTORE POSITION IN ORIGINAL STRING
ret

; GENERATE RANDOM TOWN / PERSON'S NAME FROM CURRENT SEED
; OUTPUT
; A = FIRST NAME LAST NAME OF TOWN IN NIBBLES
genrandomtownname:
   ld b,numrandnames
   jr genrandomname
genrandommanname:
   ld b,outlawfirstnameslen
genrandomname:
   call randmax32   ; GET FIRST RANDOM NUMBER
   push af
   call randmax32   ; GET LAST RANDOM NUMBER
   rlca
   rlca
   rlca
   rlca
   ld b,a
   pop af
   or b
ret

; OUTPUTS
; A = FIRST AND LAST NAMES IN NIBBLES
getrandomwantedmanname:
   ; CHANGE TABLE LOOKUPS TO PEOPLE
   ld bc,outlawfirstnames
   ld (doubletable1-2),bc
   ld bc,outlawlastnames
   jr extractdoublename

; GENERATE RANDOM TOWN NAME FROM CURRENT SEED
getrandomtownname:
   ; CHANGE TABLE LOOKUPS TO TOWNS
   ld bc,firstrandnameslist
   ld (doubletable1-2),bc
   ld bc,lastrandnameslist

; GET PERSONS NAME FROM NIBBLES
; INPUTS
; A = FIRST NAME | LAST NAME IN NIBBLES
; OUTPUTS
; DE = STRING OF SPRITE NAME
extractdoublename:
   ld (doubletable2-2),bc
   push de
   ; USE STR_TEMP TO GENERATE TOWN NAME TEXT
   ld de,str_temp
   ; GET RANDOM NAME
   push af
   and %11110000 ; GET LEFT NIBBLE
   rrca
   rrca
   rrca
   rrca
   ld hl,outlawfirstnames:doubletable1
   call vectorlookuphl
   ; GET FIRST NAME INTO DE
   call copystr3

   ; CREATE SPACE
   ld hl,str_space
   call copystr
   pop af
 
   and %00001111 ; GET RIGHT NIBBLE
   ; COPY SECOND RANDOM NAME
   ;ld b,numrandnames
   ;call randmax32
   ld hl,outlawlastnames:doubletable2
   call vectorlookuphl
   ; COPY 255 MARKER
   call copystr4;3;copystr2 
   pop de
ret



yesno_text:   defb "  YES NO",255
space_text:   defb "(FIRE) ",255
clear_text:   defb "        ",255

;clearstatusbaricon
;   push hl
;   push af
;   ; CLEAR STATUS BAR OBJECT AREA
;   ld hl,statusbar_iconpos
;   ld a,&C0
;   call ClearTile
;   ld hl,statusbar_iconpos+4
;   call ClearTile
;   ld hl,statusbar_iconpos+8
;   call ClearTile
;   pop af
;   pop hl
;ret
clearstatusbarinput:
   push hl
   push de
   push bc
   ; CLEAR STATUS BAR OBJECT AREA
   ld hl,space_iconpos
   ld de,clear_text
   call gra_wr_string2
   pop bc
   pop de
   pop hl
ret

waityesno:
   ld de,yesno_text
   ld hl,space_iconpos
   call gra_wr_string2
   ; WAIT FOR PLAYER TO PRESS BUTTON
   call waitoption_yes_no 
   jp clearstatusbarinput
waitspace:
   ld de,space_text
   ld hl,space_iconpos
   call gra_wr_string2
   ; WAIT FOR PLAYER TO PRESS BUTTON
   call waitoption_spacebar
   jp clearstatusbarinput