; BLOCK ID, SCREEN ID, (LEFT) TILE ID, IN BUILDING, DAMAGE COUNT                            
;treedamagetable
;  defb 0,0,0,0,0  
;  defb 0,0,0,0,0  
;  defb 0,0,0,0,0  
;  defb 0,0,0,0,0  
;  defb 0,0,0,0,0
;  defb 255

; FORCE ALL SPRITES TO DRAW THEIR BUFFER AS WE ARE ABOUT TO MAKE CHANGES TO THE TILES
; NEEDS TO BE DONE IN THE OPPOSITE WAY THEY WERE DRAWN TO PREVENT BUFFER OVERLAP ERRORS
forceredrawallspritesfunc:
  push hl
  pop ix
  jr forceredrawbufferthissprite
forceredrawallsprites:
  push hl
  ld hl,spritetablebackward
  ld bc,forceredrawallspritesfunc
  finishforcedrawallsprites:
  ld (spritefunc-2),bc
  ld b,numsprites
  call scanspritetable
  pop hl
ret

;forceredrawallspritesfunc2
;  push hl
;  pop ix
;  jp grabbgdrawsprite
  ;jp findnextmcpupdate
; FORCE ALL SPRITES TO GRAB BUFFER AND REDRAW THEMSELVES AS WE JUST CHANGED SOME TILES
forceredrawallsprites2:
  push hl
  ld hl,spritetableforward
  ld bc,forceredrawallspritesfunc2
  jr finishforcedrawallsprites

; FORCE CURRENT SPRITE IN IX TO REDRAW BUFFER ERASING IT FROM SCREEN
; INPUTS
; IX = SPRITE TO ERASE
forceredrawbufferthissprite:
  ; RESTORE IF WE HAVE BUFFER
  bit 1,(ix+2)
  ret z
  push hl
  call restoremybuffer
  pop hl
  res 1,(ix+2)            ; CLEAR BUFFER
ret

findexistingdamageslot_cf:
  ld a,(inbuilding)
  ld d,a
  ld bc,(currblockid)
  ; FIND EXISTING TREE DAMAGE SLOT
  ld ix,treedamagetable
  treedamageloop2:
    ld a,(ix+0) ; END OF LIST
    cp 255
    jp z,returnfalse2

    cp b ; BLOCK ID
    jr nz,gotonextslot
    ld a,(ix+1)
    cp c ; SCREEN ID
    jr nz,gotonextslot
    ld a,(ix+3)
    cp d ; IN BUILDING
    jr nz,gotonextslot
    ld a,(ix+2)
    cp l ; TILE ID
    jr nz,gotonextslot
    ; RETURN RESULT
    ld a,(ix+4)
    scf
    ret

    gotonextslot:
      call movenextdamageslot
  jr treedamageloop2

createnewdamageslot:
  ; FIND EMPTY TREE DAMAGE SLOT
  ld ix,treedamagetable
  treedamageloop:
    ld a,(ix+0) ; END OF LIST
    inc a;cp 255
    jr z,overwriteexistingslot

    ld a,(ix+4) ; IF DAMAGE IS 0, IT IS EMPTY
    or a
    jr z,foundemptytreedamage

    call movenextdamageslot
  jr treedamageloop

overwriteexistingslot:
  ld ix,treedamagetable
foundemptytreedamage:
  ld bc,(currblockid)
  ld (ix+0),b
  ld (ix+1),c
  ld (ix+2),l  ; TILE ID
  ld a,(inbuilding)
  ld (ix+3),a  ; IN BUILDING ID
  ld a,10
  ld (ix+4),a ; SET MAX DAMAGE COUNT
ret

decexistingdamageslot_cf:
  ld a,(ix+4)
  dec a
  or a                 ; DON'T ALLOW LESS THAN 0
  jp z,cleardamageslot
  ld (ix+4),a
  ret
  cleardamageslot:
  ld (ix+0),0   ; CLEAR DAMAGE SLOT ONCE IT REACHES 0
  xor a         ; THIS FORCES CUT DOWN TREE TO CLEAR ITS DAMAGE, SO WE CAN GROW A NEW TREE
ret

movenextdamageslot:
  push bc
  ld bc,5
  add ix,bc
  pop bc
ret

; SPAWN OBJECT FROM DESTROYED TREE, ROCK, ETC
; TILE ID, OBBJECT ID IN SPRITE LIST, OBJECT TYPE
spawnlumber:              defb 62,s_lumber,250
spawnundergroundentrance: defb 124,124,226
spawndirt:                defb 0,s_dirt,254
spawndungeonentrance:     defb 124,s_dungeonentrance,247
spawnironore:             defb ironore,s_ironore,250
spawnsunkenwreckentrance: defb 124,s_dungeonentrance,204
spawngraveentrance:       defb 124,s_dungeonentrance,202

; IF WE HIT ROCK ORE WITH A PICKAXE
; E.G. ROUND TOWERS
; HL = OBJECT TILE WE HIT
pickhitrockore:
  call deactivateandclearsprite
  ; CHECK TO SEE IF WALL HAS DAMAGE ALREADY
  call advancedamage
  or a
  ; IF WE REACHED COMPLETE DAMAGE, ERASE TREE
  jp nz,axesound

  ld de,spawnironore
  jr cleartreeside

; IF WE HIT A HIDDEN ENTRANCE WITH A PICKAXE
; E.G. ROUND TOWERS
; HL = OBJECT TILE WE HIT
pickhitrockentrance:
  call deactivateandclearsprite
  ; CHECK TO SEE IF WALL HAS DAMAGE ALREADY
  call advancedamage
  or a
  ; IF WE REACHED COMPLETE DAMAGE, ERASE TREE
  jp nz,axesound

  ld de,spawndungeonentrance
  jr cleartreeside

; IF WE HIT A HIDDEN ENTRANCE WITH A PICKAXE
; E.G. ROUND TOWERS
; HL = OBJECT TILE WE HIT
pickhitgraveentrance:
  call deactivateandclearsprite
  ; CHECK TO SEE IF WALL HAS DAMAGE ALREADY
  call advancedamage
  or a
  ; IF WE REACHED COMPLETE DAMAGE, ERASE TREE
  jp nz,axesound

  ld de,spawngraveentrance
  jr cleartreeside_norespawn

; IF WE HIT A HIDDEN ENTRANCE WITH A PICKAXE
; E.G. ROUND TOWERS
; HL = OBJECT TILE WE HIT
pickhitwoodentrance:
  call deactivateandclearsprite
  ; CHECK TO SEE IF WALL HAS DAMAGE ALREADY
  call advancedamage
  or a
  ; IF WE REACHED COMPLETE DAMAGE, ERASE TREE
  jp nz,axesound

  ld de,spawnsunkenwreckentrance
  jr cleartreeside

; IF WE HIT A ROCK WITH A PICK AXE
; HL = OBJECT TILE WE HIT
axehitbush:
  call deactivateandclearsprite
  jr clearfoliage
pickhitrock:
  call deactivateandclearsprite
  ; CHECK TO SEE IF ROCK HAS DAMAGE
  call advancedamage
  or a
  ; IF WE REACHED COMPLETE DAMAGE, ERASE TREE
  jp nz,axesound
  
  clearfoliage: ; JUST ERASE BUSH STRAIGHT AWAY, DON'T COUNT DAMAGE
  ; DESTROY AXE / ARROW
  ;call deactivateandclearsprite
  ; WE NEED TO REDRAW PLAYER BUFFER SO IT DOESN'T GET PASTED TO BACKGROUND HERE
  ld ix,playerspritedata
  call forceredrawbufferthissprite

  ld de,spawndirt
  jr cleartreeside

axehitbushentrance: ; JUST ERASE BUSH STRAIGHT AWAY, DON'T COUNT DAMAGE
  ; DESTROY AXE / ARROW
  call deactivateandclearsprite
  ; WE NEED TO REDRAW PLAYER BUFFER SO IT DOESN'T GET PASTED TO BACKGROUND HERE
  ld ix,playerspritedata
  call forceredrawbufferthissprite

  ld de,spawnundergroundentrance
  jr cleartreeside

; IF WE HIT WOOD WITH AN ARROW / AXE
; HL = OBJECT TILE WE HIT
arrowhittreeright:
  dec hl                           ; CLEAR LEFT SIDE FIRST
arrowhittreeleft:
  call deactivateandclearsprite
  ; CHECK TO SEE IF TREE HAS DAMAGE
  call advancedamage
  or a
  ; IF WE REACHED COMPLETE DAMAGE, ERASE TREE
  jp nz,axesound

  ld de,spawnlumber
  ; ERASE TREE / ROCK
  call cleartreeside               ; CLEAR LEFT SIDE
  inc hl                           ; CLEAR RIGHT SIDE - BELOW
  ld de,spawnlumber

; CLEAR SIDE OF TRUNK AND BRANCHES OF TREE
; INPUTS
cleartreeside_norespawn:
  ld a,1
  ld (norespawn-1),a
  jr docleartreeside
; HL = TILEMAP LOCATION OF OBJECT MAP
; DE = PTR TO IDs OF SPAWNED OBJECT FROM DESTRUCTION OF TREE,ETC
cleartreeside:
  xor a
  ld (norespawn-1),a
  docleartreeside:
  ; SET UP SPAWN DETAILS OF OBJECT TO BE CREATED AFTER DESTRUCTION OF TREE
  ld a,(de)
  ld (spawnedobject_selfmod-1),a
  inc de
  ld a,(de)
  ld (spawnedobject_selfmod2-1),a
  inc de
  ld a,(de)
  ld (spawnedobjecttype_selfmod-1),a

  ; CLEAR SPRITES BY FORCING ALL SPRITES TO DRAW THEIR BUFFER
  ; NEEDS TO BE DONE IN REVERSE ORDER SO BUFFER OVERLAPS DON'T CORRUPT SCREEN
  ; WE NEED TO DO THIS BEFORE CLEARING TREES AS SPRITES MAY BE IN VICINITY AND
  ; THEIR BUFFERS WILL BECOME INCORRECT
  call forceredrawallsprites

  ; WE NEED TO REDRAW PLAYER BUFFER SO IT DOESN'T GET PASTED TO BACKGROUND HERE
  ld ix,playerspritedata
  call forceredrawbufferthissprite

  ; CLEAR PLAYER SPRITE BUFFER FORCE TO REDRAW
  ; IN CASE WE WERE BEHIND TREE AND PLAYER SPRITE IS TRASHED
  push hl

  ; CLEAR OBJECT TILE MAP - MAKE PICKABLE OBJECT
  ld (hl),250:spawnedobjecttype_selfmod

  ; MOVE TO GRAPHIC TILE MAP - MAKE LUMBER 
  ld h,tilemap0h           
  ld a,62:spawnedobject_selfmod
  ld (hl),a     
  push hl
  call redrawsingletile_notrans  ; REDRAW EMPTY TILE
  pop hl

  ; REDRAW GROUND TILE BEHIND BRANCHES, BUT ONLY IF TILE ID CLEARED IS OVER 20 (NOT TOP ROW)
  ld a,l
  sub tilemap_width_tiles
  jr c,skipredrawinguppergroundtile

  ld l,a
  ld a,(hl)
  push hl
  call redrawsingletile_notrans  ; REDRAW EMPTY TILE
  pop hl

  skipredrawinguppergroundtile:

  ; MOVE TO UPPER LEVEL GRAPHIC TILE MAP  
  ; REDRAW ANY UPPER LEVEL TILE OBSCURING GROUND TILE
  ld h,tilemap1h    ;call movetotilemap1
  ; CLEAR BRANCHES SO THEY DON'T REDRAW
  ld (hl),0

  ; FORCE ALL SPRITES TO REDRAW AND GET BUFFERS AS WE HAVE FINISHED CHANGING BACKGROUND TILES
  call forceredrawallsprites2

  ld a,l
  add tilemap_width_tiles
  ld l,a
  ; REDRAW ANY BRANCHES THAT MAY BE OBSCURING CLEARED LOWER LEVEL TILE
  ld a,(hl)
  call checkifredrawtreetops  

  pop hl

  ; ADD A PICKABLE OBJECT TO THE FIXED QUEST SPRITE LIST
  ; THIS ENSURES LUMBER DOESN'T DISAPPEAR WHEN YOU MOVE SCREEN
  ; INPUTS
  ; DE = SPRITE DATA

  ;  defb 0               ; ACTIVE   
  ;  defb 96              ; X MAP SCREEN
  ;  defb 25              ; Y MAP SCREEN
  ;  defb 11              ; IN BUILDING
  ;  defb 65              ; X TILE LOCATION
  ;  defw s_moneybag      ; PTR TO SPRITE DATA


; INPUTS
; C  = X MAP SCREEN
; B  = Y MAP SCREEN
; A  = IN BUILDING
; L  = TILE LOCATION
; D  = PTR TO SPRITE DATA

  ; CHECK IF WE WANT TO RESPAWN ON MOVING SCREENS
  ; E.G. NOT FOR BLACKBEARDS GRAVE, AS IT CAUSES PROBLEMS
  ld a,0:norespawn
  or a
  ret nz

  ld d,s_lumber:spawnedobject_selfmod2
  addfixedquestsprite:
  ld iy,quests_fixed_sprites
  findemptyfixedquestspriteloop:
    ld a,(iy+0)
    cp 255
    ret z   ; NO SPACES!
    or a
    jr z,foundemptyfixedquestsprite
   
    call movenextfixedspriteblock
  jr findemptyfixedquestspriteloop
ret
foundemptyfixedquestsprite:
  ld (iy+0),1       ; ACTIVE
  ld bc,(tilemap_cur)
  ld (iy+1),c       ; X MAP SCREEN
  ld (iy+2),b       ; Y MAP SCREEN
  ld a,(inbuilding)
  ld (iy+3),a       ; IN BUILDING
  ld (iy+4),l       ; X TILE LOCATION
  ;ld (iy+5),e       ; PTR TO SPRITE DATA
  ld (iy+6),d       ; PTR TO SPRITE DATA
ret